#include "stdafx.h"
#include "resource.h"

#include "DacDlg.h"

CDacDlg::CDacDlg()
{	
	CurrentSlot=-1;
	CounterRead=0;
	pModule=NULL;	
}

void CDacDlg::AddPrintLog(CHAR * Message)
{
	AddLog (Message);
	TCHAR TempMessage[256];
	memset(TempMessage,0, sizeof(TempMessage));
	for (DWORD i=0;i<strlen(Message);i++)
	{
		TempMessage[i]=Message[i];
	}
	CListBox List = (CListBox) this->GetDlgItem(ID_DAC_LIST);
	
	if (List!=NULL)
	{
		List.AddString(TempMessage);	
		List.SetCurSel(List.GetCount()-1);
	}
}


void CDacDlg::AbortProgramm(CHAR * Message)
{	
	AddPrintLog(Message);
	this->EndDialog(4);
}

LRESULT CDacDlg::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	CenterWindow(GetParent());

	// Init full-screen dialog.
	SHINITDLGINFO shidi;
	ZeroMemory(&shidi, sizeof(shidi));
	shidi.dwMask = SHIDIM_FLAGS;
	shidi.dwFlags = SHIDIF_SIZEDLGFULLSCREEN;
	shidi.hDlg = m_hWnd;

	if (!SHInitDialog(&shidi))
	{
		ATLTRACE(_T("Failed to init dialog.\n"));
		this->EndDialog(1);
	}

	// Create menu bar.
	SHMENUBARINFO mbi;
	memset(&mbi, 0, sizeof(mbi)); 
	mbi.cbSize = sizeof(mbi);
	mbi.hwndParent = m_hWnd;
	mbi.nToolBarId = ATL_IDM_MENU_DONECANCEL;
	mbi.hInstRes = _Module.GetResourceInstance();	

	if(!SHCreateMenuBar(&mbi))
	{
		ATLTRACE(_T("Failed to create menu bar in dialog.\n"));
		this->EndDialog(2);
	}	

	CScrollBar ScrollThis = (CScrollBar)this->GetDlgItem(ID_DAC_SCROLL);

	SCROLLINFO scinfo={sizeof(SCROLLINFO),SIF_ALL,0,0,0,0,0};
	ScrollThis.GetScrollInfo(&scinfo);
	scinfo.cbSize = sizeof(SCROLLINFO);
	scinfo.fMask=SIF_ALL;
	scinfo.nMax=SCROOL_RANGE;
	scinfo.nMin=0;
	scinfo.nPos=SCROOL_RANGE/2;	
	scinfo.nPage=500;
	ScrollThis.SetScrollInfo(&scinfo);

	this->SetDlgItemText(ID_DAC_EDIT,L"0.0");

//==============================================================

	if (CurrentSlot==-1)
	{
		MessageBox(L" ");
		AbortProgramm("No Device");
	}		

	AddPrintLog(" *******************************");
	AddPrintLog(" Module E-154                   ");
	AddPrintLog(" example for DAC TTL");
	AddPrintLog(" *******************************");

	//     Lusbapi.dll
	DWORD DllVersion;
	if((DllVersion = GetDllVersionLCARD()) != CURRENT_VERSION_LUSBAPI)
	{
		char String[128];
		sprintf(String, " Lusbapi.dll Version Error!!!   Current: %1u.%1u. Required: %1u.%1u",
			DllVersion >> 0x10, DllVersion & 0xFFFF,
			CURRENT_VERSION_LUSBAPI >> 0x10, CURRENT_VERSION_LUSBAPI & 0xFFFF);

		AbortProgramm(String);
	}
	else AddPrintLog("Lusbapi.dll Version --> OK");

	//     
	pModule = static_cast<ILE154 *>(CreateLInstance("e154"));
	if(!pModule) AbortProgramm(" Module Interface --> Bad");
	else AddPrintLog(" Module Interface --> OK");

	pModule->CloseLDevice();
	if(!pModule->OpenLDevice(CurrentSlot)) 
	{
		AbortProgramm("Error Open");
		return FALSE;
	}
	else AddPrintLogMessage1(" OpenLDevice(%u) --> OK", CurrentSlot);

	//    
	HANDLE ModuleHandle = pModule->GetModuleHandle();
	if(ModuleHandle == INVALID_HANDLE_VALUE)
	{
		AbortProgramm(" GetModuleHandle() --> Bad");
		return FALSE;
	}
	else AddPrintLog(" GetModuleHandle() --> OK");	

	//       
	CHAR ModuleName[16];
	if(!pModule->GetModuleName(ModuleName))
	{
		AbortProgramm(" GetModuleName() --> Bad");
		return FALSE;
	}
	else AddPrintLog(" GetModuleName() --> OK");
	// ,   'E-154'
	if(strcmp(ModuleName, "E154"))
	{
		AbortProgramm(" The module is not 'E-154'");
		return FALSE;
	}
	else AddPrintLog(" The module is 'E-154'");

	//    USB
	BYTE UsbSpeed;

	//      USB	
	if(!pModule->GetUsbSpeed(&UsbSpeed))
	{
		AbortProgramm(" GetUsbSpeed() --> Bad");
		return FALSE;
	}
	else AddPrintLog(" GetUsbSpeed() --> OK");
	//      USB
	AddPrintLogMessage1("   USB is in %s", UsbSpeed ? "High-Speed Mode (480 Mbit/s)" : "Full-Speed Mode (12 Mbit/s)");

	//      
	MODULE_DESCRIPTION_E154 ModuleDescription;

	//     	
	if(!pModule->GET_MODULE_DESCRIPTION(&ModuleDescription)) 
	{
		AbortProgramm(" GET_MODULE_DESCRIPTION() --> Bad");
		return FALSE;
	}
	else AddPrintLog(" GET_MODULE_DESCRIPTION() --> OK");

	//     
	ADC_PARS_E154 ap;
	//     
	if(!pModule->GET_ADC_PARS(&ap))
	{
		AbortProgramm(" GET_ADC_PARS() --> Bad");
		return FALSE;
	}
	else AddPrintLog(" GET_ADC_PARS() --> OK");

	//     
	ap.ClkSource = INT_ADC_CLOCK_E154;							//   
	ap.EnableClkOutput = ADC_CLOCK_TRANS_DISABLED_E154; 	//     
	ap.InputMode = NO_SYNC_E154;									//    
	ap.ChannelsQuantity = 0; 					// -  
	for (int i=0;i<NumChannels;i++)
	{
		if (Channels[i])
		{				
			ap.ControlTable[ap.ChannelsQuantity] = (WORD)(ap.ChannelsQuantity | (ChannelRange[i] << 0x6));
			ap.ChannelsQuantity++;
		}
	}
	//    	
	ap.AdcRate = ADCFreqkHz;						//     
	ap.InterKadrDelay =max(50, KadrDelayMs);							//    	

	//        
	AddPrintLog(" ");
	AddPrintLogMessage1(" Module E-154 (S/N %s) is ready ... ", ModuleDescription.Module.SerialNumber);
	AddPrintLog("   Module Info:");
	AddPrintLogMessage1("     Module  Revision   is '%c'", ModuleDescription.Module.Revision);
	AddPrintLogMessage2("     MCU Driver Version is %s (%s)", ModuleDescription.Mcu.Version.Version, ModuleDescription.Mcu.Version.Date);
	AddPrintLog("   Adc parameters:");
	AddPrintLogMessage1("     ChannelsQuantity = %2d", ap.ChannelsQuantity);
	AddPrintLogMessage1("     AdcRate = %8.3f kHz", ap.AdcRate);
	AddPrintLogMessage1("     InterKadrDelay = %2.4f ms", ap.InterKadrDelay);
	AddPrintLogMessage1("     KadrRate = %8.3f kHz", ap.KadrRate);

	SHORT DacSample0 = (SHORT)(0);
	if(!pModule->DAC_SAMPLE(&DacSample0, WORD(0x0))) AddPrintLog(" DAC_SAMPLE(0) --> Bad\n");

	return TRUE;
}

LRESULT CDacDlg::OnScroolCmd(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{
	CScrollBar ScrollThis = (CScrollBar)this->GetDlgItem(ID_DAC_SCROLL);

	SCROLLINFO Info={sizeof(SCROLLINFO),SIF_ALL,0,0,0,0,0};

	ScrollThis.GetScrollInfo(&Info);	

	bool Arrows=false;

	switch (wParam&0xFFFF)
	{
	case 0:
		Info.nTrackPos=Info.nPos-(SCROOL_RANGE/100);
		Arrows=TRUE;
		break;
	case 1:
		Info.nTrackPos=Info.nPos+(SCROOL_RANGE/100);
		Arrows=TRUE;
		break;
	case 2:
		Info.nTrackPos=Info.nPos-(SCROOL_RANGE/30);
		Arrows=TRUE;
		break;
	case 3:
		Info.nTrackPos=Info.nPos+(SCROOL_RANGE/30);
		Arrows=TRUE;
		break;
	case 8: return 0;
	default: break;
	}
	
	Info.nTrackPos = min(Info.nTrackPos, Info.nMax);
	Info.nTrackPos = max(Info.nTrackPos, Info.nMin);		

	int Different = Info.nPos-Info.nTrackPos;
	if (Different&&lParam)
	{	
		ScrollThis.SetScrollPos(Info.nTrackPos);			

		//     
		double Volts = (Info.nTrackPos-(SCROOL_RANGE/2))/1000.0;
		if(!pModule->DAC_SAMPLE_VOLT(Volts, TRUE)) AbortProgramm("Error Set DAC");		
		TCHAR Text[16];
		memset(Text,0,sizeof(Text));
		wsprintf(Text,L"%4.8f", Volts);
		this->SetDlgItemText(ID_DAC_EDIT, Text);
	}	
	return 0;	
}

LRESULT CDacDlg::OnCheckChanged(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{	
	WORD SetTTL=0;
	for (int i=0;i<16;i++)
	{
		CButton CheckboxItem = (CButton) this->GetDlgItem(ID_TTL0+i);
		if (CheckboxItem!=NULL)
		{
			if(CheckboxItem.GetCheck())
			{
				SetTTL|=(1<<i);
			}			
		}		
	}
	if (!pModule->TTL_OUT(SetTTL)) AbortProgramm("Error Set TTL");
	return 0;
}

LRESULT CDacDlg::OnEnableTTLOut(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CButton CheckboxItem = (CButton) this->GetDlgItem(ID_TTL_OUT_ENB);
	if (!pModule->ENABLE_TTL_OUT(CheckboxItem.GetCheck()))AbortProgramm("Error Set TTL Enable");
	return 0;
}

LRESULT CDacDlg::OnReadTTL(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	WORD SetTTL=0;
	if (!pModule->TTL_IN(&SetTTL)) AbortProgramm("Error Read TTL");
	
	for (int i=0;i<16;i++)
	{
		CButton CheckboxItem = (CButton) this->GetDlgItem(ID_TTL0+i);
		if (CheckboxItem!=NULL)
		{			
			CheckboxItem.SetCheck((SetTTL&(1<<i)));					
		}
		pModule->TTL_OUT(SetTTL);
	}
	return 0;
}

LRESULT CDacDlg::OnChangeDAC(WORD wNotifyCode, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	TCHAR  *stopstring;
	TCHAR Text[16];
	memset(Text,0,sizeof(Text));
	this->GetDlgItemText(ID_DAC_EDIT,Text,16);
	double Value=wcstod(Text,&stopstring);

	Value = min(Value,5);
	Value = max(Value, -5);

	if(!pModule->DAC_SAMPLE_VOLT(Value, TRUE)) AbortProgramm("Error Set DAC");	
	else
	{
		CScrollBar ScrollThis = (CScrollBar)this->GetDlgItem(ID_DAC_SCROLL);
		int ScroolValue = (int)(Value*1000);
		ScroolValue+=(SCROOL_RANGE/2);
		ScrollThis.SetScrollPos(ScroolValue);
	}

	return 0;
}

LRESULT CDacDlg::OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{	
	EndDialog(wID);
	return 0;
}


LRESULT CDacDlg::OnDoneCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{	
	EndDialog(wID);
	return 0;
}

LRESULT CDacDlg::OnCloseDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	if(pModule!=NULL)pModule->CloseLDevice();
	return TRUE;
}



