#include "stdafx.h"
#include "resource.h"

#include "LIB\DEV_STD\USB_defs.h"

#include "DeviceFindDlg.h"


CDeviceFindDlg::CDeviceFindDlg()
{
	DeviceHandle=INVALID_HANDLE_VALUE;	
	CurrentSlot=-1;
	NumDevices=0;
}

LRESULT CDeviceFindDlg::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	CenterWindow(GetParent());	

	CComboBox DevicesCb = (CComboBox)this->GetDlgItem(ID_COMBOBOX_FIND);
	if(CurrentSlot==-1)
	{		
		BOOL Temp=FALSE;
		OnBeginFind(0,0,NULL,Temp);
	}

	return TRUE;
}

LRESULT CDeviceFindDlg::OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	EndDialog(wID);
	return 0;
}

BOOL CDeviceFindDlg::GetDeviceName(LPWSTR DevName)
{
	if (DeviceHandle!=INVALID_HANDLE_VALUE)
	{
		_ControlRequest Request = {TRUE, 11,0,0};
		DWORD ControlTimeout=500;
		DWORD BytesReturned=0;		
		if(DeviceIoControl(DeviceHandle, IOCTL_CONTROL_SET_CONTROL_TIMEOUT_MS, &ControlTimeout,sizeof(DWORD),NULL,NULL,&BytesReturned,NULL))
		{
			CHAR ModuleName[16]="";
			if(DeviceIoControl(DeviceHandle,IOCTL_CONTROL_PIPE_VENDOR, &Request,sizeof(Request),(LPVOID)ModuleName, sizeof(ModuleName),&BytesReturned,NULL))
			{
				for(int i=0;i<sizeof(ModuleName);i++)
				{
					DevName[i]=ModuleName[i];
				}
				return TRUE;
			}
		}		
	}
	return FALSE;
}



LRESULT CDeviceFindDlg::OnBeginFind(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	if (DeviceHandle!=INVALID_HANDLE_VALUE)
	{
		CloseHandle(DeviceHandle);
	}

	DeviceHandle=INVALID_HANDLE_VALUE;	
	CurrentSlot=-1;
	NumDevices=0;

	CComboBox DevicesCb = (CComboBox)this->GetDlgItem(ID_COMBOBOX_FIND);
	DevicesCb.ResetContent();	

	TCHAR DevName[7]=L"";
	TCHAR ModuleName[16]=L"";
	TCHAR ModuleNameAdded[32]=L"";
	for (int i=0;i<MAX_USB_DEVICES;i++)
	{
		memset(DevName,0,sizeof(DevName));
		swprintf(DevName,L"DEV%d:\0",i);
		DeviceHandle=CreateFile(DevName,
                    GENERIC_READ | GENERIC_WRITE,
                    FILE_SHARE_READ | FILE_SHARE_WRITE,
                    NULL, 0, 0, NULL);
		if (DeviceHandle!=INVALID_HANDLE_VALUE)
		{
			if(!GetDeviceName(ModuleName))
			{
				swprintf(ModuleName,L"Unknown");				
			}			
			Slots[DevicesCb.GetCount()]=i;
			NumDevices++;
			swprintf(ModuleNameAdded,L"%s, Slot %d", ModuleName,i);				
			DevicesCb.AddString(ModuleNameAdded);
			CloseHandle(DeviceHandle);
			DeviceHandle=INVALID_HANDLE_VALUE;
		}
	}

	if(DevicesCb.GetCount())
	{
		DevicesCb.SetCurSel(0);		
		BOOL Temp=FALSE;
		OnComboboxChange(WM_KILLFOCUS, ID_COMBOBOX_FIND, NULL, Temp);
	}
	else
	{
		SetDlgItemText(ID_COMBOBOX_FIND, L"  ");	
	}
	return 0;
}

LRESULT CDeviceFindDlg::OnComboboxChange(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	if (wNotifyCode==WM_KILLFOCUS)
	{
		if (DeviceHandle!=INVALID_HANDLE_VALUE)
		{
			CloseHandle(DeviceHandle);
		}

		CComboBox DevicesCb = (CComboBox)this->GetDlgItem(ID_COMBOBOX_FIND);
		TCHAR DevName[7]=L"";
		memset(DevName,0,sizeof(DevName));
		CurrentSlot=DevicesCb.GetCurSel();
		swprintf(DevName,L"DEV%d:\0",Slots[CurrentSlot]);
		DeviceHandle=CreateFile(DevName,
                    GENERIC_READ | GENERIC_WRITE,
                    FILE_SHARE_READ | FILE_SHARE_WRITE,
                    NULL, 0, 0, NULL);
		if (DeviceHandle==INVALID_HANDLE_VALUE)
		{
			SetDlgItemText(ID_COMBOBOX_FIND, L" ");	
		}	

		CloseHandle(DeviceHandle);
		DeviceHandle=INVALID_HANDLE_VALUE;
	}
	return 0;
}

