// MainDlg.h : interface of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

class CMainDlg : public CDialogImpl<CMainDlg>, public CUpdateUI<CMainDlg>,
		public CMessageFilter, public CIdleHandler
{
private:
	TCHAR NumChannelsString[3];
	TCHAR ConfFilePath[256];
	int NumWorkingChannels;
	CDeviceFindDlg DevicesDlg;
	S_ExampleWTLConf ExampleWTLConf;
public:
	enum { IDD = IDD_MAINDLG };

	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL OnIdle();

	// UI update map
	BEGIN_UPDATE_UI_MAP(CMainFrame)
		UPDATE_ELEMENT(ID_VIEW_STATUS_BAR, UPDUI_MENUBAR)
	END_UPDATE_UI_MAP()

	BEGIN_MSG_MAP(CMainDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(ID_APP_ABOUT, OnAppAbout)	
		COMMAND_ID_HANDLER(ID_MENU_RUN_ADC, OnRunADC)
		COMMAND_ID_HANDLER(ID_MENU_RUN_FIND_DEVICE, OnRunFindDevice)	
		COMMAND_ID_HANDLER(ID_MENU_RUN_MULTIMITER, OnMultimiter)	
		COMMAND_ID_HANDLER(ID_MENU_RUN_DAC_TTL	, OnDAC_TTL)			
		COMMAND_ID_HANDLER(IDOK, OnOK)
        MESSAGE_HANDLER(WM_DESTROY, OnCloseDialog)		
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
		MESSAGE_HANDLER(WM_HSCROLL, OnHorzScroll)
		MESSAGE_HANDLER(WM_VSCROLL, OnVertScroll)				
		COMMAND_ID_HANDLER(ID_CHECK_CHANNEL1, OnCheckChanged)		
		COMMAND_ID_HANDLER(ID_CHECK_CHANNEL2, OnCheckChanged)		
		COMMAND_ID_HANDLER(ID_CHECK_CHANNEL3, OnCheckChanged)		
		COMMAND_ID_HANDLER(ID_CHECK_CHANNEL4, OnCheckChanged)		
		COMMAND_ID_HANDLER(ID_CHECK_CHANNEL5, OnCheckChanged)		
		COMMAND_ID_HANDLER(ID_CHECK_CHANNEL6, OnCheckChanged)		
		COMMAND_ID_HANDLER(ID_CHECK_CHANNEL7, OnCheckChanged)		
		COMMAND_ID_HANDLER(ID_CHECK_CHANNEL8, OnCheckChanged)		
		COMMAND_ID_HANDLER(ID_CHECK_CHANNEL9, OnCheckChanged)		
		COMMAND_ID_HANDLER(ID_CHECK_CHANNEL10, OnCheckChanged)		
		COMMAND_ID_HANDLER(ID_CHECK_CHANNEL11, OnCheckChanged)		
		COMMAND_ID_HANDLER(ID_CHECK_CHANNEL12, OnCheckChanged)		
		COMMAND_ID_HANDLER(ID_CHECK_CHANNEL13, OnCheckChanged)		
		COMMAND_ID_HANDLER(ID_CHECK_CHANNEL14, OnCheckChanged)		
		COMMAND_ID_HANDLER(ID_CHECK_CHANNEL15, OnCheckChanged)		
		COMMAND_ID_HANDLER(ID_CHECK_CHANNEL16, OnCheckChanged)		
	END_MSG_MAP()    


// Handler prototypes (uncomment arguments if needed):
//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	
	
	LRESULT OnDAC_TTL(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnMultimiter(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnRunADC(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnRunFindDevice(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);	
	LRESULT OnAppAbout(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnHorzScroll(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/);
	LRESULT OnVertScroll(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/);	
    LRESULT OnCloseDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/);	
    
	LRESULT OnCheckChanged(WORD wNotifyCode, WORD wID, 
		HWND hWndCtl, BOOL& bHandled);

	void CloseDialog(int nVal);
};
