// DynLoad.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>


//  E-154.
//        Lusbapi.dll
//******************************************************************************
#include <stdio.h>
//#include <conio.h>
#include "LoadDll.h"				//   
#include "LCARD_USB_DRIVER\WinCE\lusbapiWinCE\lusbapi\Include\Lusbapi.h"				//  

#define CHANNELS_QUANTITY			(0x4)

//    
void AbortProgram(char *ErrorString, bool AbortionFlag = true);

//   -   
const WORD MaxVirtualSoltsQuantity = 127;

//      DLL
TLoadDll *pLoadDll;

//  
DWORD DllVersion;
//    
ILE154 *pModule;
//  
HANDLE ModuleHandle;
//  
char ModuleName[16];
//    USB
BYTE UsbSpeed;
//      
MODULE_DESCRIPTION_E154 ModuleDescription;
//     
ADC_PARS_E154 ap;
//     
const double AdcRate = 100.0;
//    
const WORD InputRangeIndex = ADC_INPUT_RANGE_5000mV_E154;

//------------------------------------------------------------------------
//  
//------------------------------------------------------------------------
int _tmain(int argc, _TCHAR* argv[])
{
	WORD i;

	//   
//	system("cls");

	AddLog(" ******************************************");
	AddLog(" Module E-154                              ");
	AddLog(" Console example for DLL dynamic loading 	");
	AddLog(" ******************************************");

	//    "Lusbapi.dll"
	pLoadDll = new TLoadDll(L"Lusbapi.dll");
	if(!pLoadDll) AbortProgram(" Can't alloc 'TLoadDll' object!!!");
	//      ?
	if(!pLoadDll->GetDllHinstance()) AbortProgram(" 'Lusbapi.dll' Dynamic Loading --> Bad");
	else AddLog(" 'Lusbapi.dll' Dynamic Loading --> OK");

	//     
	pGetDllVersion GetDllVersion = (pGetDllVersion)pLoadDll->CallGetDllVersion();
	if(!GetDllVersion) AbortProgram(" Address of GetDllVersion() --> Bad");
	else AddLog(" Address of GetDllVersion() --> OK");

	//     Lusbapi.dll
	if((DllVersion = GetDllVersion()) != CURRENT_VERSION_LUSBAPI)
	{
		char String[128];
		sprintf(String, " Lusbapi.dll Version Error!!!   Current: %1u.%1u. Required: %1u.%1u",
											DllVersion >> 0x10, DllVersion & 0xFFFF,
											CURRENT_VERSION_LUSBAPI >> 0x10, CURRENT_VERSION_LUSBAPI & 0xFFFF);

		AbortProgram(String);
	}
	else AddLog(" Lusbapi.dll Version --> OK");

	//     
	pCreateInstance CreateLInstance = (pCreateInstance)pLoadDll->CallCreateLInstance();
	if(!CreateLInstance) AbortProgram(" Address of CreateLInstance() --> Bad!!!");
	else AddLog(" Address of CreateLInstance() --> OK");

	//     
	pModule = static_cast<ILE154 *>(CreateLInstance("e154"));
	if(!pModule) AbortProgram(" Module Interface --> Bad");
	else AddLog(" Module Interface --> OK");

	//    E-154   256  
	for(i = 0x0; i < MaxVirtualSoltsQuantity; i++) if(pModule->OpenLDevice(i)) break;
	// - ?
	if(i == MaxVirtualSoltsQuantity) AbortProgram(" Can't find any module E-154 in first 127 virtual slots!");
	else AddLogMessage1(" OpenLDevice(%u) --> OK", i);

	//    
	ModuleHandle = pModule->GetModuleHandle();
	if(ModuleHandle == INVALID_HANDLE_VALUE) AbortProgram(" GetModuleHandle() --> Bad");
	else AddLog(" GetModuleHandle() --> OK");

	//       
	if(!pModule->GetModuleName(ModuleName)) AbortProgram(" GetModuleName() --> Bad");
	else AddLog(" GetModuleName() --> OK");
	// ,   'E-154'
	if(strcmp(ModuleName, "E154")) AbortProgram(" The module is not 'E-154'");
	else AddLog(" The module is 'E-154'");

	//      USB
	if(!pModule->GetUsbSpeed(&UsbSpeed)) AbortProgram(" GetUsbSpeed() --> Bad");
	else AddLog(" GetUsbSpeed() --> OK");
	//      USB
	AddLogMessage1("   USB is in %s", UsbSpeed ? "High-Speed Mode (480 Mbit/s)" : "Full-Speed Mode (12 Mbit/s)");

	//     
	if(!pModule->GET_MODULE_DESCRIPTION(&ModuleDescription)) AbortProgram(" GET_MODULE_DESCRIPTION() --> Bad");
	else AddLog(" GET_MODULE_DESCRIPTION() --> OK");

	//     
	if(!pModule->GET_ADC_PARS(&ap)) AbortProgram(" GET_ADC_PARS() --> Bad");
	else AddLog(" GET_ADC_PARS() --> OK");
	//     
	ap.ClkSource = INT_ADC_CLOCK_E154;							//   
	ap.EnableClkOutput = ADC_CLOCK_TRANS_DISABLED_E154; 	//     
	ap.InputMode = NO_SYNC_E154;									//    
	ap.ChannelsQuantity = CHANNELS_QUANTITY; 					// -  
	//   
	for(i = 0x0; i < ap.ChannelsQuantity; i++) ap.ControlTable[i] = (WORD)(i | (ADC_INPUT_RANGE_5000mV_E154 << 0x6));
	ap.AdcRate = AdcRate;								//     
	ap.InterKadrDelay = 0.0;							//    
	//       
	if(!pModule->SET_ADC_PARS(&ap)) AbortProgram(" SET_ADC_PARS() --> Bad");
	else AddLog(" SET_ADC_PARS() --> OK");

	//    
	AddLog(" ");
	AddLogMessage1(" Module E-154 (S/N %s) is ready ... ", ModuleDescription.Module.SerialNumber);
	AddLog("   Module Info:");
	AddLogMessage1("     Module  Revision   is '%c'", ModuleDescription.Module.Revision);
	AddLogMessage2("     AVR Driver Version is %s (%s)", ModuleDescription.Mcu.Version.Version, ModuleDescription.Mcu.Version.Date);
	AddLog("   Adc parameters:");
	AddLogMessage1("     ChannelsQuantity = %2d", ap.ChannelsQuantity);
	AddLogMessage1("     AdcRate = %8.2f kHz", ap.AdcRate);
	AddLogMessage1("     InterKadrDelay = %2.5f ms", ap.InterKadrDelay);
	AddLogMessage1("     KadrRate = %8.2f kHz", ap.KadrRate);

	// .....
	//        ,
	// ,    
	// .....

	//    -   
	AddLog("");
	AbortProgram(" The program was completed successfully!!!", false);
}

//------------------------------------------------------------------------
//   
//------------------------------------------------------------------------
void AbortProgram(char *ErrorString, bool AbortionFlag)
{
	//   
	if(pModule)
	{
		//   
		if(!pModule->ReleaseLInstance()) AddLog(" ReleaseLInstance() --> Bad");
		else AddLog(" ReleaseLInstance() --> OK");
		//     
		pModule = NULL;
	}
	//  
	if(pLoadDll) { delete pLoadDll; pLoadDll = NULL; }

	//   
	if(ErrorString) AddLog(ErrorString);

	//   	
	//if(kbhit()) { while(kbhit()) getchar(); }

	//   -   
	if(AbortionFlag) exit(0x1);
	//     
	else return;
}

