// ReadData.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>
//******************************************************************************
//  E-154.
//         
//           .
//          100 .
//******************************************************************************
#include <stdio.h>
//#include <conio.h>
#include "LCARD_USB_DRIVER\WinCE\lusbapiWinCE\lusbapi\Include\Lusbapi.h"

#define CHANNELS_QUANTITY			(0x4)

//    
void AbortProgram(char *ErrorString, bool AbortionFlag = true);
//      
DWORD WINAPI ServiceReadThread(PVOID /*Context*/);
//     
void ShowThreadErrorMessage(void);

//   -  
//   (  )
const WORD MaxVirtualSoltsQuantity = 127;

//  
HANDLE hFile;

//    
HANDLE hReadThread;
DWORD ReadTid;

//  
DWORD DllVersion;
//    
ILE154 *pModule;
//  
HANDLE ModuleHandle;
//  
char ModuleName[16];
//    USB
BYTE UsbSpeed;
//      
MODULE_DESCRIPTION_E154 ModuleDescription;
//     
ADC_PARS_E154 ap;

// -   ( 32)  . ReadData()
DWORD DataStep = 64*1024;
//   NDataBlock   DataStep   
const WORD NDataBlock = 80;
//     
const double AdcRate = 5000.0;
//  
SHORT *ReadBuffer;

//      
bool IsReadThreadComplete, IsThreadStopping;

//      
WORD ReadThreadErrorNumber;

//  -
DWORD Counter = 0x0, OldCounter = 0xFFFFFFFF;

//------------------------------------------------------------------------
//  
//------------------------------------------------------------------------
int _tmain(int argc, _TCHAR* argv[])
{
	WORD i;
//	WORD DacSample;
//	DWORD FifoOverflowFlag, FifoSize, MaxFifoBytesUsed;
//	double FifoMaxPercentLoad;
//	DWORD x, y;	

	//      
	IsReadThreadComplete = false;
	//       
	ReadBuffer = NULL;
	//      
	hReadThread = NULL;
	//     :(
	hFile = INVALID_HANDLE_VALUE;
	//      
	ReadThreadErrorNumber = 0x0;

	AddLog(" *******************************");
	AddLog(" Module E-154                   ");
	AddLog(" Console example for ADC Stream ");
	AddLog(" *******************************");

	//     Lusbapi.dll
	if((DllVersion = GetDllVersionLCARD()) != CURRENT_VERSION_LUSBAPI)
	{
		char String[128];
		sprintf(String, " Lusbapi.dll Version Error!!!   Current: %1u.%1u. Required: %1u.%1u",
											DllVersion >> 0x10, DllVersion & 0xFFFF,
											CURRENT_VERSION_LUSBAPI >> 0x10, CURRENT_VERSION_LUSBAPI & 0xFFFF);

		AbortProgram(String);
	}
	else AddLog(" Lusbapi.dll Version --> OK");

	//     
	pModule = static_cast<ILE154 *>(CreateLInstance("e154"));
	if(!pModule) AbortProgram(" Module Interface --> Bad");
	else AddLog(" Module Interface --> OK");

	//    E-154   256  
	for(i = 0x0; i < MaxVirtualSoltsQuantity; i++) if(pModule->OpenLDevice(i)) break;
	// - ?
	if(i == MaxVirtualSoltsQuantity) AbortProgram(" Can't find any module E-154 in first 127 virtual slots!");
	else AddLogMessage1(" OpenLDevice(%u) --> OK", i);

	//    
	ModuleHandle = pModule->GetModuleHandle();
	if(ModuleHandle == INVALID_HANDLE_VALUE) AbortProgram(" GetModuleHandle() --> Bad");
	else AddLog(" GetModuleHandle() --> OK");	

	//       
	if(!pModule->GetModuleName(ModuleName)) AbortProgram(" GetModuleName() --> Bad");
	else AddLog(" GetModuleName() --> OK");
	// ,   'E-154'
	if(strcmp(ModuleName, "E154")) AbortProgram(" The module is not 'E-154'");
	else AddLog(" The module is 'E-154'");

	//      USB	
	if(!pModule->GetUsbSpeed(&UsbSpeed)) AbortProgram(" GetUsbSpeed() --> Bad");
	else AddLog(" GetUsbSpeed() --> OK");
	//      USB
	AddLogMessage1("   USB is in %s", UsbSpeed ? "High-Speed Mode (480 Mbit/s)" : "Full-Speed Mode (12 Mbit/s)");

	//     
	if(!pModule->GET_MODULE_DESCRIPTION(&ModuleDescription)) AbortProgram(" GET_MODULE_DESCRIPTION() --> Bad");
	else AddLog(" GET_MODULE_DESCRIPTION() --> OK");

	//     
	if(!pModule->GET_ADC_PARS(&ap)) AbortProgram(" GET_ADC_PARS() --> Bad");
	else AddLog(" GET_ADC_PARS() --> OK");
	//     
	ap.ClkSource = INT_ADC_CLOCK_E154;							//   
	ap.EnableClkOutput = ADC_CLOCK_TRANS_DISABLED_E154; 	//     
	ap.InputMode = NO_SYNC_E154;									//    
	ap.ChannelsQuantity = CHANNELS_QUANTITY; 					// -  
	//    
	for(i = 0x0; i < ap.ChannelsQuantity; i++) ap.ControlTable[i] = (WORD)(i | (ADC_INPUT_RANGE_5000mV_E154 << 0x6));
	ap.AdcRate = AdcRate;								//     
	ap.InterKadrDelay = 0.0;							//    
	//       
	if(!pModule->SET_ADC_PARS(&ap)) AbortProgram(" SET_ADC_PARS() --> Bad");
	else AddLog(" SET_ADC_PARS() --> OK");

	//    
	ReadBuffer = new SHORT[2*DataStep];
	if(!ReadBuffer) AbortProgram(" Can not allocate memory");

	//        
	hFile = CreateFile(L"\\Test.dat", GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN | FILE_FLAG_WRITE_THROUGH, NULL);
	if(hFile == INVALID_HANDLE_VALUE) AbortProgram(" Can't create file 'Test.dat'!");

	//      
	AddLog(" ");
    IsThreadStopping=false;	
	hReadThread = CreateThread(0, 0x2000, ServiceReadThread, 0, 0, &ReadTid);
	if(!hReadThread) AbortProgram(" ServiceReadThread() --> Bad");
	else AddLog(" ServiceReadThread() --> OK");

	//        
	AddLog(" ");
	AddLogMessage1(" Module E-154 (S/N %s) is ready ... ", ModuleDescription.Module.SerialNumber);
	AddLog("   Module Info:");
	AddLogMessage1("     Module  Revision   is '%c'", ModuleDescription.Module.Revision);
	AddLogMessage2("     MCU Driver Version is %s (%s)", ModuleDescription.Mcu.Version.Version, ModuleDescription.Mcu.Version.Date);
	AddLog("   Adc parameters:");
	AddLogMessage1("     ChannelsQuantity = %2d", ap.ChannelsQuantity);
	AddLogMessage1("     AdcRate = %8.3f kHz", ap.AdcRate);
	AddLogMessage1("     InterKadrDelay = %2.4f ms", ap.InterKadrDelay);
	AddLogMessage1("     KadrRate = %8.3f kHz", ap.KadrRate);

	//         
	AddLog(" Press any key if you want to terminate this program...");
	while(!IsReadThreadComplete)
	{
		if(OldCounter != Counter) { AddLogMessage2(" Counter %3u from %3u\r", Counter, NDataBlock); OldCounter = Counter; }
		else Sleep(20);
	}

	//      
	WaitForSingleObject(hReadThread, INFINITE);

	if(!pModule->STOP_ADC()) AbortProgram("  STOP_ADC()");

	//        
	AddLog("");
	if(ReadThreadErrorNumber) { AbortProgram(NULL, false); ShowThreadErrorMessage(); }
	else AbortProgram(" The program was completed successfully!!!", false);
}

//------------------------------------------------------------------------
// ,     
//------------------------------------------------------------------------
DWORD WINAPI ServiceReadThread(PVOID /*Context*/)
{	
	WORD RequestNumber;
	DWORD FileBytesWritten;	
	//       / 
	IO_REQUEST_LUSBAPI IoReq[2];

	//       USB-  
	if(!pModule->STOP_ADC()) { ReadThreadErrorNumber = 0x1; IsReadThreadComplete = true; return 0x0; }

	//      
	for(int i = 0x0; i < 2; i++)
	{		
		//   IoReq
		IoReq[i].Buffer = ReadBuffer + i*DataStep;
		IoReq[i].NumberOfWordsToPass = DataStep;
		IoReq[i].NumberOfWordsPassed = 0x0;
		IoReq[i].Overlapped = NULL;
		IoReq[i].TimeOut = (DWORD)(DataStep/ap.AdcRate + 1000);
	}

	//      
	RequestNumber = 0x0;	

	//  
	if(pModule->START_ADC())
	{
		//   
		for(int k = 0x0; k < NDataBlock; k++)
		{
			//      	
			RequestNumber ^= 0x1;
			if(!pModule->ReadData(&IoReq[RequestNumber])) { ReadThreadErrorNumber = 0x2; break; }
			if(ReadThreadErrorNumber) break;

			//      
			if(!WriteFile(	hFile,													// handle to file to write to
		    					IoReq[RequestNumber^0x1].Buffer,					// pointer to data to write to file
								2*DataStep,	 											// number of bytes to write
	    						&FileBytesWritten,									// pointer to number of bytes written
						   	NULL			  											// pointer to structure needed for overlapped I/O
							   )) { ReadThreadErrorNumber = 0x4; break; }

			if(ReadThreadErrorNumber) break;			
			else Sleep(20);
			Counter++;
		}

      IsThreadStopping=true;	   
	}
	else { ReadThreadErrorNumber = 0x6; }
	
	//       
	IsReadThreadComplete = true;
	//      
	return 0x0;
}


//------------------------------------------------------------------------
//    
//------------------------------------------------------------------------
void ShowThreadErrorMessage(void)
{
	switch(ReadThreadErrorNumber)
	{
		case 0x1:
			AddLog(" ADC Thread: STOP_ADC() --> Bad");
			break;

		case 0x2:
			AddLog(" ADC Thread: ReadData() --> Bad");
			break;

		case 0x3:
			AddLog(" ADC Thread: Timeout is occured!");
			break;

		case 0x4:
			AddLog(" ADC Thread: Writing data file error!");
			break;

		case 0x5:
			//     ,   
			AddLog(" ADC Thread: The program was terminated!");
			break;

		case 0x6:
			AddLog(" ADC Thread: START_ADC() --> Bad");
			break;

		case 0x7:
			AddLog(" ADC Thread: Can't cancel ending input and output (I/O) operations!");
			break;

		default:
			AddLog(" Unknown error!");
			break;
	}

	return;
}

//------------------------------------------------------------------------
//   
//------------------------------------------------------------------------
void AbortProgram(char *ErrorString, bool AbortionFlag)
{
	//   
	if(pModule)
	{
		//   
		if(!pModule->ReleaseLInstance()) AddLog(" ReleaseLInstance() --> Bad");
		else AddLog(" ReleaseLInstance() --> OK");
		//     
		pModule = NULL;
	}

	//   
	if(ReadBuffer) { delete[] ReadBuffer; ReadBuffer = NULL; }
	//     
	if(hReadThread) { CloseHandle(hReadThread); hReadThread = NULL; }
	//    
	if(hFile != INVALID_HANDLE_VALUE) { CloseHandle(hFile); hFile = INVALID_HANDLE_VALUE; }

	//   
	if(ErrorString) AddLog(ErrorString);

	//   -   
	if(AbortionFlag) exit(0x1);
	//        
	else return;
}


