#include "stdafx.h"
#include <windows.h>
#include "LCARD_USB_DRIVER\WinCE\lusbapiWinCE\lusbapi\Include\lusbapi.h"
#include "wlusbapi.h"
//#pragma argsused

static ILE154 *pModule;
//  
static HANDLE ModuleHandle;
//  
static char ModuleName[16];
//    USB
static BYTE UsbSpeed;
//      
static MODULE_DESCRIPTION_E154 ModuleDescription;
//     
static ADC_PARS_E154 ap;

DWORD WINAPI ServiceRealTImeReadThread(PVOID /*Context*/);

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
	AddLog("DllEntryPoint Begin");
	return 1;
}
//------------------------------------------------------------------------
//    
//------------------------------------------------------------------------
__declspec(dllexport) DWORD WINAPI WE154GetDllVersion(VOID)
{
	AddLog("WE154GetDllVersion Begin");
	return GetDllVersionLCARD();
}
//------------------------------------------------------------------------
//    
//------------------------------------------------------------------------
void BadExit(void);

__declspec(dllexport) DWORD WINAPI LV_OpenE154(VOID)
{
	AddLog("LV_OpenE154 Begin");

	int i;

	BadExit();

	//     
	pModule = static_cast<ILE154 *>(CreateLInstance("e154"));
	if(!pModule) { BadExit(); AddLog("LV_OpenE154 -1"); return -1; }

	//    E14-154   WORD MAX_VIRTUAL_SLOTS_QUANTITY_LUSBAPI  
	for(i = 0x0; i < MAX_VIRTUAL_SLOTS_QUANTITY_LUSBAPI; i++) if(pModule->OpenLDevice(i)) break;
	// - ?
	if(i == MAX_VIRTUAL_SLOTS_QUANTITY_LUSBAPI) { BadExit();AddLog("LV_OpenE154 -2"); return -2; }	

	//    
	ModuleHandle = pModule->GetModuleHandle();
	if(ModuleHandle == INVALID_HANDLE_VALUE) { BadExit(); AddLog("LV_OpenE154 -3");return -3; }

	//       
	if(!pModule->GetModuleName(ModuleName)) { BadExit();AddLog("LV_OpenE154 -4"); return -4; }

	// ,   'E14-154'
	if(strcmp(ModuleName, "E154")) { BadExit(); AddLog("LV_OpenE154 -5");return -5; }

	//      USB
	if(!pModule->GetUsbSpeed(&UsbSpeed)) { BadExit(); AddLog("LV_OpenE154 -6"); return -6; }

	//     
	if(!pModule->GET_MODULE_DESCRIPTION(&ModuleDescription)) { BadExit(); AddLog("LV_OpenE154 -7"); return -7; }

	AddLog("LV_OpenE154 End");

	return 1;
}

__declspec(dllexport) DWORD WINAPI LV_CloseE154(VOID)
{
	AddLog("LV_CloseE154 Begin");
	BadExit();
	return 0;
}

void BadExit(void)
{
	AddLog("BadExit");

	//   
	if(pModule)
	{
		//   
		pModule->ReleaseLInstance();

		//     
		pModule = NULL;
	}
}
// -----------------------------------------------------------------------------
// ---------------------------------- E154 -------------------------------------
// -----------------------------------------------------------------------------
//------------------------------------------------------------------------
//    
//------------------------------------------------------------------------
__declspec(dllexport) LPVOID WINAPI WE154CreateInstance(VOID)
{
	AddLog("WE154CreateInstance Begin");
	return CreateLInstance("E154");
}
//------------------------------------------------------------------------
//    
//------------------------------------------------------------------------
__declspec(dllexport) HANDLE WINAPI WE154GetModuleHandle(LPVOID lptr)
{
	AddLog("WE154GetModuleHandle Begin");
	return ((ILE154*)lptr)->GetModuleHandle();
}
//------------------------------------------------------------------------
//        USB 
//------------------------------------------------------------------------
__declspec(dllexport) BOOL WINAPI WE154OpenLDevice(LPVOID lptr, WORD VirtualSlot)
{
	AddLog("WE154OpenLDevice Begin");
	return (BOOL)((ILE154*)lptr)->OpenLDevice(VirtualSlot);
}
//------------------------------------------------------------------------
//     
//------------------------------------------------------------------------
__declspec(dllexport) BOOL WINAPI WE154CloseLDevice(LPVOID lptr)
{
	AddLog("WE154CloseLDevice Begin");
	return (BOOL)((ILE154*)lptr)->CloseLDevice();
}
// -----------------------------------------------------------------------
//     
// -----------------------------------------------------------------------
__declspec(dllexport) BOOL WINAPI WE154ReleaseLDevice(LPVOID lptr)
{
	AddLog("WE154ReleaseLDevice Begin");
	return (BOOL)((ILE154*)lptr)->ReleaseLInstance();
}
// -----------------------------------------------------------------------
//    
// -----------------------------------------------------------------------
__declspec(dllexport) BOOL WINAPI WE154GetModuleName(LPVOID lptr, BYTE *ModuleName)
{
	AddLog("WE154GetModuleName Begin");
	return (BOOL)((ILE154*)lptr)->GetModuleName((PCHAR)ModuleName);
}
// -----------------------------------------------------------------------
//          
// -----------------------------------------------------------------------
/*__declspec(dllexport) INT WINAPI WE154GetLastErrorString(LPVOID lptr, LPTSTR lpBuffer, DWORD nSize)
{
return ((ILE154*)lptr)->GetLastErrorString(lpBuffer, nSize);
} */
// -----------------------------------------------------------------------
//    
// -----------------------------------------------------------------------
/*__declspec(dllexport) BOOL WINAPI WE154GET_LBIOS_VERSION(LPVOID lptr, DWORD *LbiosVersion)
{
return (BOOL)((ILE154*)lptr)->GET_LBIOS_VERSION(LbiosVersion);
} */
// -----------------------------------------------------------------------
//     
// -----------------------------------------------------------------------
__declspec(dllexport) BOOL WINAPI WE154GET_CUR_ADC_PARS(LPVOID lptr, ADC_PARS_E154 *wam)
{
	AddLog("WE154GET_CUR_ADC_PARS Begin");
	if(((ILE154*)lptr)->GET_ADC_PARS(wam)) {
		return TRUE;
	} else return FALSE;
}
// -----------------------------------------------------------------------
//      
// -----------------------------------------------------------------------
__declspec(dllexport) BOOL WINAPI WE154FILL_ADC_PARS(LPVOID lptr, ADC_PARS_E154 *wam)
{
	AddLog("WE154FILL_ADC_PARS Begin");
	if(((ILE154*)lptr)->SET_ADC_PARS(wam)) {
		return TRUE;
	} else return FALSE;
}
// -----------------------------------------------------------------------
//    
// -----------------------------------------------------------------------
__declspec(dllexport) BOOL WINAPI WE154START_ADC(LPVOID lptr)
{
	AddLog("WE154START_ADC Begin");

	return (BOOL)((ILE154*)lptr)->START_ADC();
}
// -----------------------------------------------------------------------
//   
// -----------------------------------------------------------------------
__declspec(dllexport) BOOL WINAPI WE154STOP_ADC(LPVOID lptr)
{
	AddLog("WE154STOP_ADC Begin");

	return (BOOL)((ILE154*)lptr)->STOP_ADC();
}
// -----------------------------------------------------------------------
//       
// -----------------------------------------------------------------------
__declspec(dllexport) BOOL WINAPI WE154ADC_KADR(LPVOID lptr, SHORT *Data)
{
	AddLog("WE154ADC_KADR Begin");

	return (BOOL)((ILE154*)lptr)->ADC_KADR(Data);
}
// -----------------------------------------------------------------------
//         
// -----------------------------------------------------------------------
static int test;
__declspec(dllexport) double WINAPI LV_SAMPLE_E154(DWORD Channel, DWORD UseCalibr, DWORD *error)
{
	AddLog("LV_SAMPLE_E154 Begin");

	double f=0.0;
	SHORT adc;
	BOOL result;

	result=pModule->ADC_SAMPLE(&adc, (WORD)Channel);
	*error=(result == TRUE) ? 1 : 0;
	if(result == FALSE) return f;

	// f=(result == TRUE) ? adc : 0;
	// f = f*ADC_INPUT_RANGES_E154[(Channel >> 6) & 3]/2048.;
	result=pModule->ProcessOnePoint(adc, &f, Channel, UseCalibr, TRUE);
	*error=(result == TRUE) ? 1 : 0;

	return f;
}
// -----------------------------------------------------------------------
//       
// -----------------------------------------------------------------------
__declspec(dllexport) BOOL WINAPI WE154ReadData(LPVOID lptr, IO_REQUEST_LUSBAPI *ReadRequest)
{
	AddLog("WE154ReadData Begin");

	return (BOOL)((ILE154*)lptr)->ReadData(ReadRequest);
}
// -----------------------------------------------------------------------
//       
// -----------------------------------------------------------------------
__declspec(dllexport) BOOL WINAPI LV_OUTDA_E154(double value)
{
	AddLog("LV_OUTDA_E154 Begin");

	short val;

	val=(short)(value*128./5.12);
	return (BOOL)pModule->DAC_SAMPLE(&val, 0);
}
// -----------------------------------------------------------------------
//        
// -----------------------------------------------------------------------
static int TtlOutEnabled;
__declspec(dllexport) BOOL WINAPI WE154ENABLE_TTL_OUT(LPVOID lptr, BOOL flag)
{
	AddLog("WE154ENABLE_TTL_OUT Begin");

	return (BOOL)((ILE154*)lptr)->ENABLE_TTL_OUT(flag ? true : false);
}
// -----------------------------------------------------------------------
//         
// -----------------------------------------------------------------------
__declspec(dllexport) DWORD WINAPI LV_GETTTL_E154(DWORD *error)
{
	AddLog("LV_GETTTL_E154 Begin");

	BOOL result;
	unsigned short ttl;

	result=pModule->TTL_IN(&ttl);
	if(result == FALSE)
	{
		*error=0;
		return 0;
	}

	*error=1;
	return (DWORD) ttl;
}
// -----------------------------------------------------------------------
//         
// -----------------------------------------------------------------------
__declspec(dllexport) BOOL WINAPI LV_SETTTL_E154(DWORD TtlOut)
{
	AddLog("WINAPI LV_SETTTL_E154 Begin");

	if(!TtlOutEnabled)
	{
		if(!pModule->ENABLE_TTL_OUT(true)) { return 0; }
		TtlOutEnabled=1;
	}

	return (BOOL) pModule->TTL_OUT((WORD)TtlOut);
}
// -----------------------------------------------------------------------
//  /     
// -----------------------------------------------------------------------
__declspec(dllexport) BOOL WINAPI WE154ENABLE_FLASH_WRITE(LPVOID lptr, BOOL EnableFlashWrite)
{
	AddLog("WE154ENABLE_FLASH_WRITE Begin");

	return (BOOL)((ILE154*)lptr)->ENABLE_FLASH_WRITE(EnableFlashWrite ? true : false);
}
// -----------------------------------------------------------------------
//     
// -----------------------------------------------------------------------
__declspec(dllexport) BOOL WINAPI WE154D_FLASH_ARRAY(LPVOID lptr, unsigned char *ptr)
{
	AddLog("WE154D_FLASH_ARRAY Begin");

	return (BOOL)((ILE154*)lptr)->WRITE_FLASH_ARRAY((unsigned char *)ptr);
}
// -----------------------------------------------------------------------
//     
// -----------------------------------------------------------------------
__declspec(dllexport) BOOL WINAPI  WEREAD_FLASH_ARRAY(LPVOID lptr, unsigned char *ptr)
{
	AddLog("WEREAD_FLASH_ARRAY Begin");

	return (BOOL)((ILE154*)lptr)->READ_FLASH_ARRAY((unsigned char *) ptr);
}
// -----------------------------------------------------------------------
//        
// -----------------------------------------------------------------------
__declspec(dllexport) BOOL WINAPI WE154GET_MODULE_DESCR(LPVOID lptr, MODULE_DESCRIPTION_E154 *wmd)
{
	AddLog("WE154GET_MODULE_DESCR Begin");

	if(((ILE154*)lptr)->GET_MODULE_DESCRIPTION(wmd)) {
		return TRUE;
	} else return FALSE;
}
// -----------------------------------------------------------------------
//        
// -----------------------------------------------------------------------
__declspec(dllexport) BOOL WINAPI WE154SAVE_MODULE_DESCR(LPVOID lptr, MODULE_DESCRIPTION_E154 *wmd)
{
	AddLog("WE154SAVE_MODULE_DESCR Begin");

	return (BOOL)((ILE154*)lptr)->SAVE_MODULE_DESCRIPTION(wmd);
}
// -----------------------------------------------------------------------
//                 
//                  usb   suspend
// -----------------------------------------------------------------------
/*__declspec(dllexport) BOOL WINAPI WE154SetSuspendModeFlag(LPVOID lptr, BOOL SuspendModeFlag)
{
return (BOOL)((ILE154*)lptr)->SetSuspendModeFlag(SuspendModeFlag ? true : false);
}
*/

//------------------------------------------------------------------------
//    
//------------------------------------------------------------------------
__declspec(dllexport) DWORD WINAPI LV_CreateChannelE154(DWORD channel, DWORD gain)
{
	AddLog("LV_CreateChannelE154 Begin - End");

	return (channel & 7) | ((gain & 3) << 6);
}


// -----------------------------------------------------------------------
//       
// -----------------------------------------------------------------------
// Nch -    ( 1  128)
// Channels -    
// Rate      
// AdcDelay -    ( ),  
// InputMode, SynchroAdType, SynchroAdMode, SynchroAdChanne   ( )
// SynchroAdPorog    
// SetRate        
// SetAdcDelay     ()
__declspec(dllexport) BOOL WINAPI LV_SET_ADC_SYCHRO_READ_PARAMETERS(DWORD Nch, DWORD *Channels,
																	float Rate, float AdcDelay, DWORD InputMode, DWORD SynchroAdType, DWORD SynchroAdMode, DWORD SynchroAdChannel,
																	float SynchroAdPorog, float *SetRate, float *SetAdcDelay)
{
	AddLog("LV_SET_ADC_SYCHRO_READ_PARAMETERS Begin");	

	if(pModule==NULL||pModule->GetModuleHandle()==INVALID_HANDLE_VALUE||pModule->GetModuleHandle()==NULL)
	{
		AddLog("LV_SET_ADC_SYCHRO_READ_PARAMETERS Error ModuleHandle");
		return false;
	}	

	int i;
	double adc_ms, rate_ms, inter_kadr_ms;

	if(!Nch)
	{
		AddLog("LV_SET_ADC_SYCHRO_READ_PARAMETERS Error Num Channels");
		return false;
	}

	//     
	if(!pModule->GET_ADC_PARS(&ap))
	{
		AddLog("LV_SET_ADC_SYCHRO_READ_PARAMETERS Error Get ADC Pars1");
		return false;
	}

	//    
	ap.ClkSource = INT_ADC_CLOCK_E154;							//   
	ap.EnableClkOutput = ADC_CLOCK_TRANS_DISABLED_E154; 	//     
	ap.InputMode = (WORD)InputMode;
	ap.SynchroAdType=(WORD)SynchroAdType;
	ap.SynchroAdMode=(WORD)SynchroAdMode;
	ap.SynchroAdChannel=(WORD)SynchroAdChannel;
	ap.SynchroAdPorog=(SHORT)(SynchroAdPorog*2048./ADC_INPUT_RANGES_E154[(SynchroAdChannel >> 6) & 3]);

	ap.ChannelsQuantity = (WORD)Nch; 		// -  
	for(i = 0x0; i < ap.ChannelsQuantity; i++) ap.ControlTable[i] = (WORD)Channels[i];

	if(AdcDelay < 0.007) ap.AdcRate=120.;
	else ap.AdcRate = 1./AdcDelay;					//     

	//    
	if(Rate > 120000) Rate=120000;
	adc_ms=1./ap.AdcRate;
	rate_ms=1000./Rate;
	inter_kadr_ms=rate_ms-(Nch-1)*adc_ms;
	if(inter_kadr_ms < 0) inter_kadr_ms=0;
	ap.InterKadrDelay = inter_kadr_ms;			//    

	//       
	if(!pModule->SET_ADC_PARS(&ap))
	{
		AddLog("LV_SET_ADC_SYCHRO_READ_PARAMETERS Error Set ADC Pars");
		return false;
	}

	if(!pModule->GET_ADC_PARS(&ap))
	{
		AddLog("LV_SET_ADC_SYCHRO_READ_PARAMETERS Error Get ADC Pars2");
		return false;
	}

	*SetAdcDelay=(float)(1./ap.AdcRate);
	*SetRate=(float)(ap.KadrRate*1000.);


	AddLog("LV_SET_ADC_SYCHRO_READ_PARAMETERS End");

	return true;
}

DWORD WINAPI ServiceReadThread(PVOID /*Context*/);
//     
void ShowThreadErrorMessage(void);

//    
HANDLE hReadThread;
DWORD ReadTid;


// -   ( 32)  . ReadData()
DWORD DataStep = 32*1024;	//     64 

//  
SHORT *AdcBuffer, *GlobalPtr;

//      
bool IsReadThreadComplete;
//      
WORD ReadThreadErrorNumber;

DWORD DataReadN, DataReadAll;;

//  -
DWORD Counter = 0x0, OldCounter = 0xFFFFFFFF;

// NPoints -  
// Data -     
// TimeOut	 ,             (    )
// result 1   , 0 
__declspec(dllexport) BOOL WINAPI LV_GET_ADC_SYNCHRO_ARRAY(DWORD NPoints, SHORT *Data, DWORD TimeOut)
{
	AddLog("LV_GET_ADC_SYNCHRO_ARRAY Begin");

	if(pModule==NULL||pModule->GetModuleHandle()==INVALID_HANDLE_VALUE||pModule->GetModuleHandle()==NULL)
	{
		AddLog("LV_GET_ADC_SYNCHRO_ARRAY Error ModuleHandle");
		return false;
	}

	int i;
	int n_wait, n;
	//         	

	if(!ap.ChannelsQuantity ) 
	{
		AddLog("LV_GET_ADC_SYNCHRO_ARRAY Error ap.ChannelsQuantity");
		return false;
	}
	if(!NPoints)
	{
		AddLog("LV_GET_ADC_SYNCHRO_ARRAY Error NPoints");
		return false;
	}

	if(!TimeOut) n_wait=250;	// 5 sec
	else n_wait=TimeOut/20;

	//      
	IsReadThreadComplete = false;

	//       
	AdcBuffer = NULL;

	//      
	hReadThread = NULL;

	//      
	ReadThreadErrorNumber = 0x0;

	DataReadN=0;
	DataReadAll=NPoints*ap.ChannelsQuantity;
	GlobalPtr=Data;

	if(DataReadAll < 128*1024)
	{
		//     64  (32 )
		n=DataReadAll/32;
		if(DataReadAll % 32) n++;
		n *= 32;

		AdcBuffer = new SHORT[n];
		if(!AdcBuffer)
		{
			AddLog("LV_GET_ADC_SYNCHRO_ARRAY Error AdcBuffer");
			return false;
		}

		//       USB-  
		if(!pModule->STOP_ADC()) { delete AdcBuffer; AddLog("LV_GET_ADC_SYNCHRO_ARRAY Error pModule->STOP_ADC"); return false; }

		//      
		
		IO_REQUEST_LUSBAPI IoReq;
		//   IoReq
		IoReq.Buffer = AdcBuffer;
		IoReq.NumberOfWordsToPass = n;
		IoReq.NumberOfWordsPassed = 0x0;
		IoReq.Overlapped = NULL;
		IoReq.TimeOut =(DWORD) (n/ap.AdcRate + 10000);		

		//  
		if(pModule->START_ADC())
		{
			//       
			if(!pModule->ReadData(&IoReq)) { delete AdcBuffer; AddLog("LV_GET_ADC_SYNCHRO_ARRAY Error pModule->ReadData(&IoReq[RequestNumber]"); return 0x0; }			
		}
		else { ReadThreadErrorNumber = 0x6; }

		//   
		if(!pModule->STOP_ADC()) ReadThreadErrorNumber = 0x1;	

		memcpy(Data, AdcBuffer, DataReadAll*2);
		
		//  
		//	Sleep(100);
		//       
		//      
		delete AdcBuffer;

		if(ReadThreadErrorNumber)
		{
			AddLog("LV_GET_ADC_SYNCHRO_ARRAY Error ReadThreadErrorNumber");
			return false;
		}
		else
		{
			AddLog("LV_GET_ADC_SYNCHRO_ARRAY End1");
			return true;
		}		
	}

	//    
	AdcBuffer = new SHORT[2*DataStep];
	if(!AdcBuffer) 
	{
		AddLog("LV_GET_ADC_SYNCHRO_ARRAY Error AdcBuffer2");
		return false;
	}

	//      
	hReadThread = CreateThread(0, 0x2000, ServiceReadThread, 0, 0, &ReadTid);
	if(!hReadThread) { delete AdcBuffer; AddLog("LV_GET_ADC_SYNCHRO_ARRAY Error hReadThread2"); return false; }


	//         
	for(i=0; i < n_wait && !IsReadThreadComplete; i++)
	{
		//if(OldCounter != Counter) { printf(" Counter %3u from %3u\r", Counter, NDataBlock); OldCounter = Counter; }
		//else
		Sleep(20);
	}

	//      
	WaitForSingleObject(hReadThread, INFINITE);

	if(ReadThreadErrorNumber) { delete AdcBuffer; AddLog("LV_GET_ADC_SYNCHRO_ARRAY Error ReadThreadErrorNumber2");return false; }

	delete AdcBuffer;


	AddLog("LV_GET_ADC_SYNCHRO_ARRAY End");

	return true;
}



//------------------------------------------------------------------------
// ,     
//------------------------------------------------------------------------
DWORD WINAPI ServiceReadThread(PVOID /*Context*/)
{
	AddLog("ServiceReadThread Begin");

	WORD RequestNumber;
	DWORD i;
	//     	
	IO_REQUEST_LUSBAPI IoReq[2];

	//       USB-  
	if(!pModule->STOP_ADC()) { ReadThreadErrorNumber = 0x1; IsReadThreadComplete = true; return 0x0; }

	//      
	for(i = 0x0; i < 0x2; i++)
	{
		//   IoReq
		IoReq[i].Buffer = AdcBuffer + i*DataStep;
		IoReq[i].NumberOfWordsToPass = DataStep;
		IoReq[i].NumberOfWordsPassed = 0x0;
		IoReq[i].Overlapped = NULL;
		IoReq[i].TimeOut = (DWORD)(DataStep/ap.AdcRate + 10000);
	}

	//      
	RequestNumber = 0x0;
	

	//  
	if(pModule->START_ADC())
	{
		//   
		while(!ReadThreadErrorNumber)
		{
			//      			
			if(!pModule->ReadData(&IoReq[RequestNumber])) { ReadThreadErrorNumber = 0x2; break; }			

			if((DataReadAll-DataReadN) < DataStep)
			{
				//   
				memcpy(&GlobalPtr[DataReadN], IoReq[RequestNumber].Buffer, 2*(DataReadAll-DataReadN));
				break;
			}
			else
			{
				memcpy(&GlobalPtr[DataReadAll], IoReq[RequestNumber].Buffer, 2*DataStep);
				DataReadN += DataStep;
			}			
			
			Counter++;
		}

	}
	else { ReadThreadErrorNumber = 0x6; }

	//   
	if(!pModule->STOP_ADC()) ReadThreadErrorNumber = 0x1;	
	
	//       
	IsReadThreadComplete = true;
	//      

	ExitThread(1);
	return 0x0;
}


int GlobalPacketSize;
SHORT *RealTimePtr;
int RealTimeReadIndex;
DWORD RealBufferSize;
static int StopEvent;
static int OverflowFlag;
static int UserIndex;

// BufferSize -    - ,        (   1 ,    )
// PacketSize -     ,          PacketSize 
//    FIFO  RealBufferSize    GlobalPacketSize
//     - RealTimeReadIndex
//      UserIndex
__declspec(dllexport) BOOL WINAPI LV_START_REAL_TIME_SAMPLING(DWORD BufferSize, DWORD PacketSize)
{
	AddLog("LV_START_REAL_TIME_SAMPLING Begin");

	if(!ap.ChannelsQuantity ) return false;
	if(BufferSize < 1024  || (BufferSize & 1)) return false;
	if(PacketSize > BufferSize/2) PacketSize=BufferSize/2;
	if(PacketSize < 32) PacketSize=32;
	if(PacketSize % 32) { PacketSize=(PacketSize/32); PacketSize=(PacketSize+1)*32; }

	//      
	IsReadThreadComplete = false;

	//       
	RealTimeReadIndex=0;
	StopEvent=0;
	GlobalPacketSize=PacketSize;
	RealBufferSize=BufferSize;
	AdcBuffer = NULL;
	UserIndex=0;

	//      
	hReadThread = NULL;

	//      
	ReadThreadErrorNumber = 0x0;

	//    
	AdcBuffer = new SHORT[2*PacketSize];
	if(!AdcBuffer) return false;

	RealTimePtr = new SHORT[RealBufferSize];
	if(!RealTimePtr) { free(AdcBuffer); return false; }

	//      
	hReadThread = CreateThread(0, 0x2000, ServiceRealTImeReadThread, 0, 0, &ReadTid);
	//SetThreadPriority(hReadThread,  THREAD_PRIORITY_TIME_CRITICAL);
	if(!hReadThread) { free(AdcBuffer); return false; }

	if(ReadThreadErrorNumber) return false;

	return true;
}

__declspec(dllexport) BOOL WINAPI LV_STOP_REAL_TIME_SAMPLING(void)
{
	AddLog("LV_STOP_REAL_TIME_SAMPLING Begin");

	StopEvent=1;

	for(;!IsReadThreadComplete;)
	{
		Sleep(20);
	}

	//      
	WaitForSingleObject(hReadThread, INFINITE);

	free(AdcBuffer); free(RealTimePtr);
	AdcBuffer=NULL;
	RealTimePtr=NULL;

	if(ReadThreadErrorNumber) return false;

	return true;
}


// index     
// overflow_flag   ,    
__declspec(dllexport) BOOL WINAPI LV_GET_REAL_TIME_INDEX(DWORD *index, DWORD *overflow_flag, DWORD *user_index)
{
	AddLog("LV_GET_REAL_TIME_INDEX Begin");

	*overflow_flag=OverflowFlag;
	*index=RealTimeReadIndex;
	*user_index=UserIndex;

	if(ReadThreadErrorNumber) return false;

	return true;
}

static int cnt=0;

// Data      
// NPoints   
__declspec(dllexport) BOOL WINAPI LV_GET_REAL_TIME_DATA(SHORT *Data, DWORD NPoints)
{
	AddLog("LV_GET_REAL_TIME_DATA Begin");

	DWORD n;

	//    FIFO  RealBufferSize    GlobalPacketSize
	//     - RealTimeReadIndex
	//      UserIndex
	if((UserIndex+NPoints) <= RealBufferSize)
	{
		memcpy(Data, &RealTimePtr[UserIndex], 2*NPoints);
		UserIndex += NPoints;
		if((DWORD)UserIndex >= RealBufferSize) UserIndex=0;
		//            for(i=0, ++cnt; i < NPoints; i++) Data[i]=cnt;
	}
	else
	{
		// 1.     
		n=RealBufferSize-UserIndex;
		memcpy(Data, &RealTimePtr[UserIndex], 2*n);

		UserIndex=0;

		//  
		memcpy(&Data[n], &RealTimePtr[UserIndex], 2*(NPoints-n));
		UserIndex += (NPoints-n);
	}

	//cnt++;

	return true;
}



//------------------------------------------------------------------------
// ,     
//------------------------------------------------------------------------
DWORD WINAPI ServiceRealTImeReadThread(PVOID /*Context*/)
{
	AddLog("ServiceRealTImeReadThread Begin");

	WORD RequestNumber;
	DWORD i;	

	IO_REQUEST_LUSBAPI IoReq[2];
	DWORD n;DWORD OldPointer;

	//       USB-  
	if(!pModule->STOP_ADC()) { ReadThreadErrorNumber = 0x1; IsReadThreadComplete = true; return 0x0; }

	//      
	for(i = 0x0; i < 0x2; i++)
	{		
		//   IoReq
		IoReq[i].Buffer = AdcBuffer + i*GlobalPacketSize;
		IoReq[i].NumberOfWordsToPass = GlobalPacketSize;
		IoReq[i].NumberOfWordsPassed = 0x0;
		IoReq[i].Overlapped = NULL;
		IoReq[i].TimeOut = 1000;
	}

	//      
	RequestNumber = 0x0;

	//  
	if(pModule->START_ADC())
	{
		//   
		while(!StopEvent)
		{
			//      
			if(!pModule->ReadData(&IoReq[RequestNumber])) { ReadThreadErrorNumber = 0x2; break; }			

			//    FIFO  RealBufferSize    GlobalPacketSize
			//     - RealTimeReadIndex
			//      UserIndex
			OldPointer=RealTimeReadIndex;
			if((RealTimeReadIndex+GlobalPacketSize) <= (int)RealBufferSize)
			{
				memcpy(&RealTimePtr[RealTimeReadIndex], IoReq[RequestNumber].Buffer, 2*GlobalPacketSize);
				RealTimeReadIndex += GlobalPacketSize;

				//   
				if((DWORD)UserIndex > OldPointer && UserIndex <= RealTimeReadIndex)   OverflowFlag=1;

				if(RealTimeReadIndex == RealBufferSize) RealTimeReadIndex=0;
			}
			else
			{
				// 1.     
				n=RealBufferSize-RealTimeReadIndex;
				memcpy(&RealTimePtr[RealTimeReadIndex], IoReq[RequestNumber].Buffer, 2*n);

				//   
				RealTimeReadIndex += n;
				if((DWORD)UserIndex > OldPointer && UserIndex <= RealTimeReadIndex)   OverflowFlag=1;

				RealTimeReadIndex=0;

				//  
				memcpy(&RealTimePtr[RealTimeReadIndex], &IoReq[RequestNumber].Buffer[n], 2*(GlobalPacketSize-n));
				RealTimeReadIndex += (GlobalPacketSize-n);
			}


			if(ReadThreadErrorNumber) break;
			else Sleep(20);
		}

	}
	else { ReadThreadErrorNumber = 0x6; }

	//   
	if(!pModule->STOP_ADC()) ReadThreadErrorNumber = 0x1;	
	
	//       
	IsReadThreadComplete = true;

	ExitThread(1);
	//      
	return 0x0;
}


__declspec(dllexport) BOOL WINAPI WEProcessArray(SHORT *src, double *dest, DWORD size, DWORD calibr, DWORD volt)
{
	AddLog("WEProcessArray Begin");
	return (BOOL)pModule->ProcessArray(src, dest, size, calibr, volt);
}

__declspec(dllexport) BOOL WINAPI WEProcessOnePoint(SHORT src, double *dest, DWORD channel, DWORD calibr, DWORD volt)
{
	AddLog("WEProcessOnePoint Begin");
	return (BOOL)pModule->ProcessOnePoint(src, dest, channel, calibr, volt);
}

__declspec(dllexport) BOOL WINAPI WEFIFO_STATUS(DWORD *FifoOverflowFlag, double *FifoMaxPercentLoad, DWORD *FifoSize, DWORD *MaxFifoBytesUsed)
{
	AddLog("WEFIFO_STATUS Begin");
	return (BOOL)pModule->FIFO_STATUS(FifoOverflowFlag, FifoMaxPercentLoad, FifoSize, MaxFifoBytesUsed);
}


__declspec(dllexport) BOOL WINAPI WEDAC_SAMPLE_VOLT(double DacData, DWORD calibr)
{
	AddLog("WEDAC_SAMPLE_VOLT Begin");
	return (BOOL)pModule->DAC_SAMPLE_VOLT(DacData, calibr);
}


__declspec(dllexport) BOOL WINAPI WE_GET_ARRAY(BYTE *Buffer, WORD Size, WORD Address)
{
	AddLog("WE_GET_ARRAY Begin");
	return (BOOL)pModule->GetArray (Buffer, Size, Address);
}

__declspec(dllexport) BOOL WINAPI WE_PUT_ARRAY(BYTE *Buffer, WORD Size, WORD Address)
{
	AddLog("WE_PUT_ARRAY Begin");
	return (BOOL)pModule->PutArray (Buffer, Size, Address);
}


